/** This is the template for all powerups!
 *  Below will have a few blanks for you to fill in with the correct missing code. Solutions can be found on the website or Github.
**/

/** All powerups including
 *  - Path spikes
 *  - Slow Time
 *  - Damage/Speed boost for towers
 */
 
int powerupCount[] = {5, 3, 3}; // Amount of each powerup remaining
final int spikes = 0, slowdown = 1, speedboost = 2;
final int spikePierce = 3; // Amount of balloons the cluster of spikes will pop before disappearing

final int slowdownLength = 7; // Amount of time that a slowdown session lasts for in seconds
final int speedBoostLength = 7; // Amount of time that a speed boost session lasts for in seconds

float slowdownAmount = 1; // The factor to multiply all balloon speeds by
int slowdownRemaining = 0;
final PVector slowdownLocation = new PVector(763, 208); 

float speedBoostAmount = 1; // Factor to multiply all tower cooldowns by
int speedBoostRemaining = 0;
final PVector speedBoostLocation = new PVector(763, 258); 

PImage spikeIcon; // Image for path spikes
PVector spikeLocation = new PVector(763, 150); // Location of spike for drag and drop
ArrayList<PVector> spikeLocations;
ArrayList<Integer> spikeData;

final PVector originalSpikeLocation = new PVector(763, 150);

boolean spikeHeld = false;

/** Reimplementation of Drag and Drop for path spikes **/
boolean withinSpikeBounds() {
  return pointRectCollision(mouseX, mouseY, spikeLocation.x, spikeLocation.y, 45);
}

boolean spikeTrashDrop() {
  PVector location = spikeLocation;
  if (location.x >= trashX1 && location.x <= trashX2 && location.y >= trashY1 && location.y <= trashY2) return true;
  return false;
}

void handleSpikePickUp() {
  if (withinSpikeBounds() && powerupCount[spikes] > 0) {
    spikeHeld = true;
    
    PVector location = spikeLocation;
    difX = (int) location.x - mouseX; // Calculate the offset values (the mouse pointer may not be in the direct centre of the tower)
    difY = (int) location.y - mouseY;
  }
}



/** --------------------FILL IN MISSING CODE HERE-------------------- */
/** This method should return true if the spike's location is on the path
 *  spikeLocation() is a PVector containing the spike's coordinates
 *  shortestPath(location) returns the shortest path between "location" and any path
 *  PATH_RADIUS is the path's radius
 */
boolean legalSpikeDrop() {
  
}



void handleSpikeDrop() {
  if (spikeTrashDrop()) {
    spikeLocation = originalSpikeLocation;
    println("Spike dropped in trash.");
  } else if (legalSpikeDrop()) {
    
    
    /** --------------------FILL IN MISSING CODE HERE-------------------- */
    /** Here you should drop the spike where it is, decrease the number of spikes remaining,
     *  add the location and pierce of the current spike into the spikeLocations and spikeData (respectively), and
     *  reset the location of the spike to originalSpikeLocation
     */
    
    
    
    println("Spike Dropped on Path");
  }
  spikeHeld = false;
}

void loadSpikeIcon() {
  spikeIcon = loadImage("spikes.png");
}
 
void drawSpikeIcon(PVector location, color colour) {
  ellipseMode(RADIUS);
  fill(colour);
  ellipse(location.x, location.y, 20, 20);
  
  imageMode(CENTER);
  image(spikeIcon, location.x, location.y);
}

void drawSpikeIcon(PVector location) {
  imageMode(CENTER);
  image(spikeIcon, location.x, location.y);
}

void drawAllSpikes() {
  for (int i = 0; i < spikeLocations.size(); i++) {
    if (spikeData.get(i) <= 0) {
      spikeData.remove(i);
      spikeLocations.remove(i);
      i--;
    }
    else {
      drawSpikeIcon(spikeLocations.get(i));
    }
  }
}

void drawCurrentSpikeIcon() {
  if (legalSpikeDrop() || spikeLocation.equals(originalSpikeLocation)) {
    drawSpikeIcon(spikeLocation, #FFFFFF);
  }
  else {
    drawSpikeIcon(spikeLocation, #F00000);
  }
}

boolean balloonSpikeCollision(PVector position) {
  
  /** --------------------FILL IN MISSING CODE HERE-------------------- */
  /** Here, given the position of a balloon as the parameter position,
   *  check every spike to see if there is a collision with the balloon.
   *  If so, return true and decrease the pierce of the spike by 1
   */
  

}

void displayPowerups() {
  fill(255);
  text("Slowdowns remaining: " + powerupCount[slowdown], 655, 184);
  text("Speed Boosts remaining: " + powerupCount[speedboost], 635, 234);
  
  color displayColour;
  
  /** Slowdown */
  if (mousePressed && withinSlowdownBounds() && powerupCount[slowdown] <= 0 && slowdownRemaining <= 0) {
    displayColour = #F00000; // Display using red error colour
  }
  else if (slowdownRemaining > 0) {
    displayColour = #81E5FF; // Display blue colour for slowdown in progress
  }
  else {
    displayColour = #FFFFFF; // Display using white colour
  }
  
  fill(displayColour);
  ellipseMode(RADIUS);
  
  ellipse(slowdownLocation.x, slowdownLocation.y, 20, 20);
  
  
  /** Speed Boosts */
  if (mousePressed && withinSpeedBoostBounds() && powerupCount[speedboost] <= 0 && speedBoostRemaining <= 0) {
    displayColour = #F00000; // Display using red error colour
  }
  else if (speedBoostRemaining > 0) {
    displayColour = #81E5FF; // Display blue colour for slowdown in progress
  }
  else {
    displayColour = #FFFFFF; // Display using white colour
  }
  fill(displayColour);
  ellipse(speedBoostLocation.x, speedBoostLocation.y, 20, 20);
  
  /** Spikes */
  if (mousePressed && withinSpikeBounds() && powerupCount[spikes] <= 0) {
    displayColour = #F00000; // Display using red error colour
  }
  else {
    displayColour = #FFFFFF; // Display using white colour
  }
  
  fill(displayColour);
  
  text("Spikes remaining: " + powerupCount[spikes], 625, 146);
  drawSpikeIcon(originalSpikeLocation, displayColour);
}

boolean withinSlowdownBounds() {
  return pointRectCollision(mouseX, mouseY, slowdownLocation.x, slowdownLocation.y, 45);
}

void handleSlowdownPress() {
  
  /** --------------------FILL IN MISSING CODE HERE-------------------- */
  /** Here, check if the player's pointer is within the slowdown button,
   *  check if the player has not used up all their slowdowns, and that
   *  a slowdown is not already in place.
   *
   *  if all those are true, decrease the slowdowns remaining, set the slowdown
   *  amount to 0.5, and refill the remaining slowdown time.
   */
  
  
}

void handleSlowdown() {
  
  /** --------------------FILL IN MISSING CODE HERE-------------------- */
  /** Check if a slowdown is in effect
   *  If so, reduce the frames of slowdown remaining by 1.
   *  If doing so turns the frames of slowdown remaining to 0,
   *  Revert the slowdownAmount to the original value of 1 (to revert to the original speed).
   */
  
  
}

/** Speed Boost Powerup */

boolean withinSpeedBoostBounds() {
  return pointRectCollision(mouseX, mouseY, speedBoostLocation.x, speedBoostLocation.y, 45);
}

void handleSpeedBoostPress() {
  if (withinSpeedBoostBounds() && powerupCount[speedboost] > 0 && speedBoostAmount == 1) {
    powerupCount[speedboost]--;
    speedBoostAmount = 0.4;
    speedBoostRemaining = speedBoostLength * 60;
  }
}

void handleSpeedBoost() {
  if (speedBoostRemaining > 0) {
    speedBoostRemaining--;
    
    if (speedBoostRemaining == 0) {
      speedBoostAmount = 1; // Revert to original speed
    }
  }
}


/** Variables and Methods that were not declared in this file */

boolean pointRectCollision(float x1, float y1, float x2, float y2, float size) { return false; }
int trashX1, trashX2, trashY1, trashY2, difX, difY, PATH_RADIUS;
